rules:
  - id: glappsec_path-traversal-go
    languages:
      - go
    pattern-sources:
      - patterns:
        - pattern-either:
            - pattern-inside: |
                func $FUNC($X string, ...) {
                  ...
                }
            - pattern-inside: |
                func $FUNC($X, ...) {
                  ...
                }
        - focus-metavariable: $X
    pattern-sinks:
      - pattern-either:
        - pattern: |
            path.Join(..., $X)
            ...
            os.OpenFile(...)
        - pattern: |-
            path.Join(..., $X)
            ...
            os.Open(...)
        - pattern: os.Open(path.Join(..., $X))
        - pattern: os.OpenFile(filepath.Join(..., $X))
    pattern-sanitizers:
      - pattern: path.Join(string(os.PathSeparator), path.Clean($X))
      - pattern: filepath.Join(string(os.PathSeparator), path.Clean($X))
      - pattern: path.Join("/", path.Clean($X))
      - pattern: filepath.Join("/", path.Clean($X))
    mode: taint
    metadata:
      confidence: HIGH
      references:
        - https://docs.gitlab.com/ee/development/secure_coding_guidelines.html#path-traversal-guidelines
      vulnerability_class:
        - Path Traversal
    message: >
      Potential path traversal detected. Make sure that the path name is 
      sanitized before passing it to sensitive functions like `os.Open()` or 
      `path.Join()`. Consult GitLab's secure coding guidelines for more information: 
      https://docs.gitlab.com/ee/development/secure_coding_guidelines.html#path-traversal-guidelines"
    severity: ERROR